// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Primary design header
//
// This header should be included by all source files instantiating the design.
// The class here is then constructed to instantiate the design.
// See the Verilator manual for examples.

#ifndef _VCAMT8D32_H_
#define _VCAMT8D32_H_  // guard

#include "verilated_heavy.h"
#include "verilated_cov.h"

//==========

class VCAMT8D32__Syms;
class VCAMT8D32_VerilatedVcd;


//----------

VL_MODULE(VCAMT8D32) {
  public:
    
    // PORTS
    // The application code writes and reads these signals to
    // propagate new values into/out from the Verilated model.
    VL_IN8(clk,0,0);
    VL_IN8(res_n,0,0);
    VL_IN8(lock,0,0);
    VL_IN8(unlock,0,0);
    VL_IN8(wr,0,0);
    VL_IN8(rd,0,0);
    VL_OUT8(dout_val,0,0);
    VL_OUT8(locked,0,0);
    VL_IN16(key,15,0);
    VL_IN64(din,39,0);
    VL_OUT64(dout,39,0);
    
    // LOCAL SIGNALS
    // Internals; generally not touched by application code
    CData/*0:0*/ CAMT8D32__DOT__STATE;
    CData/*0:0*/ CAMT8D32__DOT__NEXT_STATE;
    CData/*0:0*/ CAMT8D32__DOT__T8D32_CAM_hit;
    CData/*0:0*/ CAMT8D32__DOT__DO_IDLE;
    CData/*0:0*/ CAMT8D32__DOT__DO_LOCK;
    CData/*0:0*/ CAMT8D32__DOT__DO_READ_CAM;
    CData/*0:0*/ CAMT8D32__DOT__DO_UNLOCK;
    CData/*0:0*/ CAMT8D32__DOT__DO_WRITE_CAM;
    CData/*0:0*/ CAMT8D32__DOT__T8D32_CAM_rd;
    CData/*0:0*/ CAMT8D32__DOT__T8D32_CAM_wr;
    CData/*3:0*/ CAMT8D32__DOT__T8D32_CAM__DOT__HEAD;
    CData/*3:0*/ CAMT8D32__DOT__T8D32_CAM__DOT__HEAD_PLUS_1;
    SData/*15:0*/ CAMT8D32__DOT__T8D32_CAM__DOT__compare;
    IData/*31:0*/ CAMT8D32__DOT__T8D32_CAM__DOT__unnamedblk1__DOT__i;
    QData/*39:0*/ CAMT8D32__DOT__T8D32_CAM_rd_data;
    QData/*39:0*/ CAMT8D32__DOT__T8D32_CAM_wr_data;
    QData/*39:0*/ CAMT8D32__DOT__T8D32_CAM__DOT__MEMORY[16];
    
    // LOCAL VARIABLES
    // Internals; generally not touched by application code
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__clk;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__res_n;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__lock;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__unlock;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__wr;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__rd;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__dout_val;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__locked;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__STATE;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__NEXT_STATE;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__T8D32_CAM_hit;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__DO_IDLE;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__DO_LOCK;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__DO_READ_CAM;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__DO_UNLOCK;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__DO_WRITE_CAM;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__IS_KEY_MATCH;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__T8D32_CAM_rd;
    CData/*0:0*/ CAMT8D32__DOT____Vtogcov__T8D32_CAM_wr;
    CData/*3:0*/ CAMT8D32__DOT__T8D32_CAM__DOT____Vtogcov__HEAD;
    CData/*3:0*/ CAMT8D32__DOT__T8D32_CAM__DOT____Vtogcov__HEAD_PLUS_1;
    CData/*0:0*/ __Vtask_CAMT8D32__DOT__PUSH_T8D32_CAM__1__write;
    CData/*0:0*/ __Vfunc_CAMT8D32__DOT__POP_T8D32_CAM__2__read;
    CData/*0:0*/ __Vclklast__TOP__clk;
    CData/*0:0*/ __Vchglast__TOP__CAMT8D32__DOT__T8D32_CAM_hit;
    SData/*15:0*/ CAMT8D32__DOT____Vtogcov__key;
    SData/*15:0*/ CAMT8D32__DOT__T8D32_CAM__DOT____Vtogcov__compare;
    SData/*15:0*/ __Vfunc_CAMT8D32__DOT__T8D32_CAM__DOT__compare_fcn__3__Vfuncout;
    IData/*31:0*/ __Vfunc_CAMT8D32__DOT__T8D32_CAM__DOT__read_fcn__4__unnamedblk3__DOT__i;
    QData/*39:0*/ CAMT8D32__DOT____Vtogcov__din;
    QData/*39:0*/ CAMT8D32__DOT____Vtogcov__dout;
    QData/*39:0*/ CAMT8D32__DOT____Vtogcov__T8D32_CAM_rd_data;
    QData/*39:0*/ CAMT8D32__DOT____Vtogcov__T8D32_CAM_wr_data;
    QData/*39:0*/ __Vfunc_CAMT8D32__DOT__POP_T8D32_CAM__2__Vfuncout;
    QData/*39:0*/ __Vfunc_CAMT8D32__DOT__POP_T8D32_CAM__2__read_data;
    QData/*39:0*/ __Vfunc_CAMT8D32__DOT__T8D32_CAM__DOT__read_fcn__4__Vfuncout;
    CData/*0:0*/ __Vm_traceActivity[3];
    
    // INTERNAL VARIABLES
    // Internals; generally not touched by application code
    VCAMT8D32__Syms* __VlSymsp;  // Symbol table
  private:
    // Coverage
    void __vlCoverInsert(uint32_t* countp, bool enable, const char* filenamep, int lineno, int column,
        const char* hierp, const char* pagep, const char* commentp, const char* linescovp);
  public:
    
    // CONSTRUCTORS
  private:
    VL_UNCOPYABLE(VCAMT8D32);  ///< Copying not allowed
  public:
    /// Construct the model; called by application code
    /// The special name  may be used to make a wrapper with a
    /// single model invisible with respect to DPI scope names.
    VCAMT8D32(const char* name = "TOP");
    /// Destroy the model; called (often implicitly) by application code
    ~VCAMT8D32();
    /// Trace signals in the model; called by application code
    void trace(VerilatedVcdC* tfp, int levels, int options = 0);
    
    // API METHODS
    /// Evaluate the model.  Application must call when inputs change.
    void eval() { eval_step(); eval_end_step(); }
    /// Evaluate when calling multiple units/models per time step.
    void eval_step();
    /// Evaluate at end of a timestep for tracing, when using eval_step().
    /// Application must call after all eval() and before time changes.
    void eval_end_step();
    /// Simulation complete, run final blocks.  Application must call on completion.
    void final();
    
    // INTERNAL METHODS
  private:
    static void _eval_initial_loop(VCAMT8D32__Syms* __restrict vlSymsp);
    void _traceDump();void _traceDumpOpen();void _traceDumpClose();public:
    void __Vconfigure(VCAMT8D32__Syms* symsp, bool first);
  private:
    static QData _change_request(VCAMT8D32__Syms* __restrict vlSymsp);
    static QData _change_request_1(VCAMT8D32__Syms* __restrict vlSymsp);
  public:
    static void _combo__TOP__1(VCAMT8D32__Syms* __restrict vlSymsp);
    static void _combo__TOP__5(VCAMT8D32__Syms* __restrict vlSymsp);
  private:
    void _configure_coverage(VCAMT8D32__Syms* __restrict vlSymsp, bool first) VL_ATTR_COLD;
    void _ctor_var_reset() VL_ATTR_COLD;
  public:
    static void _eval(VCAMT8D32__Syms* __restrict vlSymsp);
  private:
#ifdef VL_DEBUG
    void _eval_debug_assertions();
#endif  // VL_DEBUG
  public:
    static void _eval_initial(VCAMT8D32__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _eval_settle(VCAMT8D32__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _initial__TOP__4(VCAMT8D32__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _sequent__TOP__3(VCAMT8D32__Syms* __restrict vlSymsp);
    static void _settle__TOP__6(VCAMT8D32__Syms* __restrict vlSymsp) VL_ATTR_COLD;
  private:
    static void traceChgSub0(void* userp, VerilatedVcd* tracep);
    static void traceChgTop0(void* userp, VerilatedVcd* tracep);
    static void traceCleanup(void* userp, VerilatedVcd* /*unused*/);
    static void traceFullSub0(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceFullTop0(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceInitSub0(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceInitTop(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    void traceRegister(VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceInit(void* userp, VerilatedVcd* tracep, uint32_t code) VL_ATTR_COLD;
} VL_ATTR_ALIGNED(VL_CACHE_LINE_BYTES);

//----------


#endif  // guard
