// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Tracing implementation internals
#include "verilated_vcd_c.h"
#include "VCAMT8D32__Syms.h"


//======================

void VCAMT8D32::_traceDump() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    __VlSymsp->__Vm_dumperp->dump(VL_TIME_Q());
}
void VCAMT8D32::_traceDumpOpen() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    if (VL_UNLIKELY(!__VlSymsp->__Vm_dumperp)) {
        __VlSymsp->__Vm_dumperp = new VerilatedVcdC();
        const char* cp = vl_dumpctl_filenamep();
        trace(__VlSymsp->__Vm_dumperp, 0, 0);
        __VlSymsp->__Vm_dumperp->open(vl_dumpctl_filenamep());
        __VlSymsp->__Vm_dumperp->changeThread();
        __VlSymsp->__Vm_dumping = true;
    }
}
void VCAMT8D32::_traceDumpClose() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    __VlSymsp->__Vm_dumping = false;
    VL_DO_CLEAR(delete __VlSymsp->__Vm_dumperp, __VlSymsp->__Vm_dumperp = nullptr);
}
void VCAMT8D32::trace(VerilatedVcdC* tfp, int, int) {
    tfp->spTrace()->addInitCb(&traceInit, __VlSymsp);
    traceRegister(tfp->spTrace());
}

void VCAMT8D32::traceInit(void* userp, VerilatedVcd* tracep, uint32_t code) {
    // Callback from tracep->open()
    VCAMT8D32__Syms* __restrict vlSymsp = static_cast<VCAMT8D32__Syms*>(userp);
    if (!Verilated::calcUnusedSigs()) {
        VL_FATAL_MT(__FILE__, __LINE__, __FILE__,
                        "Turning on wave traces requires Verilated::traceEverOn(true) call before time 0.");
    }
    vlSymsp->__Vm_baseCode = code;
    tracep->module(vlSymsp->name());
    tracep->scopeEscape(' ');
    VCAMT8D32::traceInitTop(vlSymsp, tracep);
    tracep->scopeEscape('.');
}

//======================


void VCAMT8D32::traceInitTop(void* userp, VerilatedVcd* tracep) {
    VCAMT8D32__Syms* __restrict vlSymsp = static_cast<VCAMT8D32__Syms*>(userp);
    VCAMT8D32* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    {
        vlTOPp->traceInitSub0(userp, tracep);
    }
}

void VCAMT8D32::traceInitSub0(void* userp, VerilatedVcd* tracep) {
    VCAMT8D32__Syms* __restrict vlSymsp = static_cast<VCAMT8D32__Syms*>(userp);
    VCAMT8D32* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    const int c = vlSymsp->__Vm_baseCode;
    if (false && tracep && c) {}  // Prevent unused
    // Body
    {
        tracep->declBit(c+51,"clk", false,-1);
        tracep->declBit(c+52,"res_n", false,-1);
        tracep->declBit(c+53,"lock", false,-1);
        tracep->declBit(c+54,"unlock", false,-1);
        tracep->declBus(c+55,"key", false,-1, 15,0);
        tracep->declBit(c+56,"wr", false,-1);
        tracep->declQuad(c+57,"din", false,-1, 39,0);
        tracep->declBit(c+59,"rd", false,-1);
        tracep->declBit(c+60,"dout_val", false,-1);
        tracep->declQuad(c+61,"dout", false,-1, 39,0);
        tracep->declBit(c+63,"locked", false,-1);
        tracep->declBit(c+51,"CAMT8D32 clk", false,-1);
        tracep->declBit(c+52,"CAMT8D32 res_n", false,-1);
        tracep->declBit(c+53,"CAMT8D32 lock", false,-1);
        tracep->declBit(c+54,"CAMT8D32 unlock", false,-1);
        tracep->declBus(c+55,"CAMT8D32 key", false,-1, 15,0);
        tracep->declBit(c+56,"CAMT8D32 wr", false,-1);
        tracep->declQuad(c+57,"CAMT8D32 din", false,-1, 39,0);
        tracep->declBit(c+59,"CAMT8D32 rd", false,-1);
        tracep->declBit(c+60,"CAMT8D32 dout_val", false,-1);
        tracep->declQuad(c+61,"CAMT8D32 dout", false,-1, 39,0);
        tracep->declBit(c+63,"CAMT8D32 locked", false,-1);
        tracep->declBus(c+65,"CAMT8D32 CAM_SIZE", false,-1, 31,0);
        tracep->declBus(c+66,"CAMT8D32 CAM_WIDTH", false,-1, 31,0);
        tracep->declBus(c+67,"CAMT8D32 CAM_TAG_WIDTH", false,-1, 31,0);
        tracep->declBus(c+65,"CAMT8D32 CAM_KEY_WIDTH", false,-1, 31,0);
        tracep->declBus(c+68,"CAMT8D32 KEY", false,-1, 15,0);
        tracep->declQuad(c+69,"CAMT8D32 ZERO_DATA", false,-1, 39,0);
        tracep->declBus(c+16,"CAMT8D32 STATE", false,-1, 0,0);
        tracep->declBus(c+2,"CAMT8D32 NEXT_STATE", false,-1, 0,0);
        tracep->declBit(c+3,"CAMT8D32 T8D32_CAM_hit", false,-1);
        tracep->declBit(c+4,"CAMT8D32 DO_IDLE", false,-1);
        tracep->declBit(c+5,"CAMT8D32 DO_LOCK", false,-1);
        tracep->declBit(c+6,"CAMT8D32 DO_READ_CAM", false,-1);
        tracep->declBit(c+7,"CAMT8D32 DO_UNLOCK", false,-1);
        tracep->declBit(c+8,"CAMT8D32 DO_WRITE_CAM", false,-1);
        tracep->declBit(c+64,"CAMT8D32 IS_KEY_MATCH", false,-1);
        tracep->declBit(c+9,"CAMT8D32 T8D32_CAM_rd", false,-1);
        tracep->declQuad(c+10,"CAMT8D32 T8D32_CAM_rd_data", false,-1, 39,0);
        tracep->declBit(c+12,"CAMT8D32 T8D32_CAM_wr", false,-1);
        tracep->declQuad(c+13,"CAMT8D32 T8D32_CAM_wr_data", false,-1, 39,0);
        tracep->declBus(c+71,"CAMT8D32 T8D32_CAM DATA_WIDTH", false,-1, 31,0);
        tracep->declBus(c+72,"CAMT8D32 T8D32_CAM NUM_ENTRIES", false,-1, 31,0);
        tracep->declBus(c+73,"CAMT8D32 T8D32_CAM TAG_WIDTH", false,-1, 31,0);
        tracep->declBit(c+51,"CAMT8D32 T8D32_CAM clk", false,-1);
        tracep->declBit(c+52,"CAMT8D32 T8D32_CAM res_n", false,-1);
        tracep->declBit(c+9,"CAMT8D32 T8D32_CAM rd", false,-1);
        tracep->declBit(c+12,"CAMT8D32 T8D32_CAM wr", false,-1);
        tracep->declQuad(c+13,"CAMT8D32 T8D32_CAM wr_data", false,-1, 39,0);
        tracep->declQuad(c+10,"CAMT8D32 T8D32_CAM rd_data", false,-1, 39,0);
        tracep->declBit(c+3,"CAMT8D32 T8D32_CAM hit", false,-1);
        tracep->declBus(c+74,"CAMT8D32 T8D32_CAM ADDR_WIDTH", false,-1, 31,0);
        tracep->declBus(c+75,"CAMT8D32 T8D32_CAM ENTRY_WIDTH", false,-1, 31,0);
        tracep->declBus(c+76,"CAMT8D32 T8D32_CAM ZERO_ADDR", false,-1, 3,0);
        tracep->declQuad(c+69,"CAMT8D32 T8D32_CAM ZERO_DATA", false,-1, 39,0);
        {int i; for (i=0; i<16; i++) {
                tracep->declQuad(c+17+i*2,"CAMT8D32 T8D32_CAM MEMORY", true,(i+0), 39,0);}}
        tracep->declBus(c+49,"CAMT8D32 T8D32_CAM HEAD", false,-1, 3,0);
        tracep->declBus(c+50,"CAMT8D32 T8D32_CAM HEAD_PLUS_1", false,-1, 3,0);
        tracep->declBus(c+15,"CAMT8D32 T8D32_CAM compare", false,-1, 15,0);
        tracep->declBus(c+1,"CAMT8D32 T8D32_CAM unnamedblk1 i", false,-1, 31,0);
    }
}

void VCAMT8D32::traceRegister(VerilatedVcd* tracep) {
    // Body
    {
        tracep->addFullCb(&traceFullTop0, __VlSymsp);
        tracep->addChgCb(&traceChgTop0, __VlSymsp);
        tracep->addCleanupCb(&traceCleanup, __VlSymsp);
    }
}

void VCAMT8D32::traceFullTop0(void* userp, VerilatedVcd* tracep) {
    VCAMT8D32__Syms* __restrict vlSymsp = static_cast<VCAMT8D32__Syms*>(userp);
    VCAMT8D32* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    {
        vlTOPp->traceFullSub0(userp, tracep);
    }
}

void VCAMT8D32::traceFullSub0(void* userp, VerilatedVcd* tracep) {
    VCAMT8D32__Syms* __restrict vlSymsp = static_cast<VCAMT8D32__Syms*>(userp);
    VCAMT8D32* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    vluint32_t* const oldp = tracep->oldp(vlSymsp->__Vm_baseCode);
    if (false && oldp) {}  // Prevent unused
    // Body
    {
        tracep->fullIData(oldp+1,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__unnamedblk1__DOT__i),32);
        tracep->fullBit(oldp+2,(vlTOPp->CAMT8D32__DOT__NEXT_STATE));
        tracep->fullBit(oldp+3,(vlTOPp->CAMT8D32__DOT__T8D32_CAM_hit));
        tracep->fullBit(oldp+4,(vlTOPp->CAMT8D32__DOT__DO_IDLE));
        tracep->fullBit(oldp+5,(vlTOPp->CAMT8D32__DOT__DO_LOCK));
        tracep->fullBit(oldp+6,(vlTOPp->CAMT8D32__DOT__DO_READ_CAM));
        tracep->fullBit(oldp+7,(vlTOPp->CAMT8D32__DOT__DO_UNLOCK));
        tracep->fullBit(oldp+8,(vlTOPp->CAMT8D32__DOT__DO_WRITE_CAM));
        tracep->fullBit(oldp+9,(vlTOPp->CAMT8D32__DOT__T8D32_CAM_rd));
        tracep->fullQData(oldp+10,(vlTOPp->CAMT8D32__DOT__T8D32_CAM_rd_data),40);
        tracep->fullBit(oldp+12,(vlTOPp->CAMT8D32__DOT__T8D32_CAM_wr));
        tracep->fullQData(oldp+13,(vlTOPp->CAMT8D32__DOT__T8D32_CAM_wr_data),40);
        tracep->fullSData(oldp+15,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__compare),16);
        tracep->fullBit(oldp+16,(vlTOPp->CAMT8D32__DOT__STATE));
        tracep->fullQData(oldp+17,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__MEMORY[0]),40);
        tracep->fullQData(oldp+19,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__MEMORY[1]),40);
        tracep->fullQData(oldp+21,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__MEMORY[2]),40);
        tracep->fullQData(oldp+23,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__MEMORY[3]),40);
        tracep->fullQData(oldp+25,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__MEMORY[4]),40);
        tracep->fullQData(oldp+27,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__MEMORY[5]),40);
        tracep->fullQData(oldp+29,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__MEMORY[6]),40);
        tracep->fullQData(oldp+31,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__MEMORY[7]),40);
        tracep->fullQData(oldp+33,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__MEMORY[8]),40);
        tracep->fullQData(oldp+35,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__MEMORY[9]),40);
        tracep->fullQData(oldp+37,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__MEMORY[10]),40);
        tracep->fullQData(oldp+39,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__MEMORY[11]),40);
        tracep->fullQData(oldp+41,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__MEMORY[12]),40);
        tracep->fullQData(oldp+43,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__MEMORY[13]),40);
        tracep->fullQData(oldp+45,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__MEMORY[14]),40);
        tracep->fullQData(oldp+47,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__MEMORY[15]),40);
        tracep->fullCData(oldp+49,(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__HEAD),4);
        tracep->fullCData(oldp+50,((0xfU & ((IData)(1U) 
                                            + (IData)(vlTOPp->CAMT8D32__DOT__T8D32_CAM__DOT__HEAD)))),4);
        tracep->fullBit(oldp+51,(vlTOPp->clk));
        tracep->fullBit(oldp+52,(vlTOPp->res_n));
        tracep->fullBit(oldp+53,(vlTOPp->lock));
        tracep->fullBit(oldp+54,(vlTOPp->unlock));
        tracep->fullSData(oldp+55,(vlTOPp->key),16);
        tracep->fullBit(oldp+56,(vlTOPp->wr));
        tracep->fullQData(oldp+57,(vlTOPp->din),40);
        tracep->fullBit(oldp+59,(vlTOPp->rd));
        tracep->fullBit(oldp+60,(vlTOPp->dout_val));
        tracep->fullQData(oldp+61,(vlTOPp->dout),40);
        tracep->fullBit(oldp+63,(vlTOPp->locked));
        tracep->fullBit(oldp+64,((0xbabeU == (IData)(vlTOPp->key))));
        tracep->fullIData(oldp+65,(0x10U),32);
        tracep->fullIData(oldp+66,(0x28U),32);
        tracep->fullIData(oldp+67,(8U),32);
        tracep->fullSData(oldp+68,(0xbabeU),16);
        tracep->fullQData(oldp+69,(0ULL),40);
        tracep->fullIData(oldp+71,(0x28U),32);
        tracep->fullIData(oldp+72,(0x10U),32);
        tracep->fullIData(oldp+73,(8U),32);
        tracep->fullIData(oldp+74,(4U),32);
        tracep->fullIData(oldp+75,(0x20U),32);
        tracep->fullCData(oldp+76,(0U),4);
    }
}
